using Grapevine;

namespace Test_Grapevine_V5
{
    public partial class Form1 : Form
    {
        // rest server
        public static IRestServer restServer = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            StartRestServer((int)numServerPort.Value);
        }


        private void StartRestServer(int port)
        {
            try
            {
                restServer = RestServerBuilder.UseDefaults().Build();
                restServer.Prefixes.Add($"http://+:" + port + "/");
                restServer.Start();

                listBox1.Items.Insert(0, "server started");

            }
            catch (Exception ex)
            {
                listBox1.Items.Insert(0, "server start fail: " + ex.Message);
            }
        }

        private void StopRestServer()
        {
            try
            {
                if (restServer != null)
                {
                    restServer.Stop();
                    restServer = null;

                    listBox1.Items.Insert(0, "server stopped");
                }
            }
            catch (Exception ex)
            {
                listBox1.Items.Insert(0, "server stop failed: " + ex.Message);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            StopRestServer();
        }
    }
}
